//justify
@mixin justify() {
  text-align: justify;

  &:after {
    display: inline-block;
    width: 100%;
    content: '';
  }
}

//blockCentered
@mixin blockCentered() {
  display: block;
  margin-right: auto;
  margin-left: auto;
}

//absolutePosition
@mixin absolutePosition() {
  position: absolute;
  top: 0;
  right: 0;
  bottom: 0;
  left: 0;
}

//absoluteCenter
@mixin absoluteCenter() {
  position: absolute;
  top: 50%;
  left: 50%;
  transform: translate( -50%, -50% );
}
@mixin absoluteCenterX() {
  position: absolute;
  left: 50%;
  transform: translateX( -50% );
}
@mixin absoluteCenterY() {
  position: absolute;
  top: 50%;
  transform: translateY( -50% );
}

//transform
@mixin transform-translate( $posX, $posY ) {
  -webkit-transform: translate( $posX, $posY );
  transform: translate( $posX, $posY );
}
@mixin transform-rotate( $deg ) {
  -webkit-transform: rotate( $deg + deg );
  transform: rotate( $deg + deg );
}
@mixin transform-scale( $num ) {
  -webkit-transform: scale( $num );
  transform: scale( $num );
}

//transition
@mixin transition( $property, $duration, $delay ) {
  -webkit-transition: $property $duration+s linear $delay+s;
  transition: $property $duration+s linear $delay+s;
}

//fixedCenterY
@mixin fixedCenterY() {
  position: fixed;
  top: 50%;
  transform: translateY( -50% );
}

//btnReset
@mixin btnReset() {
  padding: 0;
  background: transparent;
  border: none;
}

@mixin fadeInUpWithRotate() {
  backface-visibility: hidden;
  transform: translateZ(0);
  animation: fadeInUpWithRotate;
  animation-duration: .5s;
  animation-timing-function: ease;
  animation-fill-mode: forwards;
  animation-delay: .6s;
}

@mixin fadeAnimationWithDelay() {
  backface-visibility: hidden;
  transform: translateZ(0);
  animation: fadeInUp;
  animation-duration: .5s;
  animation-timing-function: ease;
  animation-fill-mode: forwards;
  animation-delay: .9s;
}

/// Event wrapper
/// @author Harry Roberts
/// @param {Bool} $self [false] - Whether or not to include current selector
/// @link https://twitter.com/csswizardry/status/478938530342006784 Original tweet from Harry Roberts
@mixin on-event($self: false) {
    @if $self {
        &,
        &:hover,
        &:active,
        &:focus {
            @content;
        }
    } @else {
        &:hover,
        &:active,
        &:focus {
            @content;
        }
    }
}

/// Make a context based selector a little more friendly
/// @author Hugo Giraudel
/// @param {String} $context
@mixin when-inside($context) {
    #{$context} & {
        @content;
    }
}

/// adaptive
@mixin sm {
    @media screen and (min-width: $phone-landscape) {
        @content;
    }
}
@mixin mobile {
    @media screen and (max-width: $phone-landscape - 1) {
        @content;
    }
}
@mixin md {
    @media screen and (min-width: $tablet-portrait) {
        @content;
    }
}
@mixin portable {
    @media screen and (max-width: $tablet-portrait - 1) {
        @content;
    }
}
@mixin lg {
    @media screen and (min-width: $tablet-landscape) {
        @content;
    }
}
@mixin tablet {
    @media screen and (max-width: $tablet-landscape - 1) {
        @content;
    }
}
@mixin xl {
    @media screen and (min-width: $desktop) {
        @content;
    }
}
@mixin hd {
    @media screen and (min-width: $high-desktop) {
        @content;
    }
}
